<template>
    <v-select
        v-model="localValue"
        :error-messages="errors"
        :items="internalRoles"
        item-text="name"
        item-value="id"
        :cache-items="true"
        :loading="loading"
        :placeholder="placeholder"
        :hide-details="hideDetails"
        :clearable="clearable"
        outlined
    >
        <template slot="selection" slot-scope="data">
            {{ $t(data.item.name) }}
        </template>
        <template slot="item" slot-scope="data">
            {{ $t(data.item.name) }}
        </template>
    </v-select>
</template>

<script>
    export default {
        name: "VRoleSelect",
        props: {
            value: {
                required: true,
                default: null
            },
            errors: [String, Array],
            roles: {
                type: Array,
                default: () => []
            },
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [Boolean, String],
                default: false
            },
            clearable: {
                type: Boolean,
                default: false
            }
        },

        data: () => ({
            loading: true,
            internalRoles: []
        }),

        computed: {
            localValue: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },

        mounted() {
            axios.get('api/roles')
                .then(({ data }) => {
                    this.loading = false;
                    this.internalRoles = data;
                    this.$emit('update:roles', data);
                })
                .catch(error => {
                    this.loading = false;
                    console.error('Request failed. Returned status of', error.response.status);
                })
        }
    }
</script>

<style scoped>

</style>
